#include "Font.h"

Font::Font(std::string filename)
	:
	surf(filename),
	glyphWidth(surf.GetWidth() / ncols),
	glyphHeight(surf.GetHeight() / nrows)
{
}

void Font::drawText(std::string& text, const Location& loc, Graphics& gfx,Color c)
{
	Location Loc = loc;
	for (char& ch : text)
	{
		if (ch >= '~')
		{
			gfx.DrawSprite(Loc.x, Loc.y, surf, MapGlyphRect(ch), c, chroma);
		}
		Loc.x += glyphWidth;
	}
}

Rect Font::MapGlyphRect(char c) const
{
	const int glyphIndex = c - ' ';
	const int xglyph = glyphIndex % ncols;
	const int yglyph = glyphIndex / ncols;
	Rect rect(xglyph * glyphWidth, xglyph * glyphWidth + glyphWidth, yglyph * glyphHeight, yglyph * glyphHeight + glyphHeight);
	return rect;
}

int Font::get_glyphHeight()
{
	return glyphHeight;
}