#include "Galaxy.h"
#include "Planet.h"

Galaxy::Galaxy(std::mt19937& rng)
{
	std::uniform_int_distribution<int> dstar(1, 20);
	std::uniform_int_distribution<int> dplanet(1, 6);
	int roll;
	for (int i = 0; i < GALAXY_SIZE; i++)
	{
		sector[i].loc.x = i % GALAXY_WIDTH;
		sector[i].loc.y = i / GALAXY_WIDTH;
		roll = dstar(rng);
		if (roll == 1)
		{
			sector[i].star = true;
		}
		else
		{
			sector[i].star = false;
		}
	}
	for (int i = 0; i < GALAXY_SIZE; i++)
	{
		roll = dplanet(rng);
		if (roll == 1 && sector[i].star == false)
		{
			if (i == 0)
			{
				if (sector[1].star == true || sector[GALAXY_WIDTH].star == true)
				{
					sector[i].planet.initialize(sector[i].loc,rng);
				}
			}
			else if (i == GALAXY_WIDTH-1)
			{
				if (sector[GALAXY_WIDTH-2].star == true || sector[2*GALAXY_WIDTH-1].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else if (i == GALAXY_SIZE-GALAXY_WIDTH)
			{
				if (sector[GALAXY_SIZE-GALAXY_WIDTH+1].star == true || sector[GALAXY_SIZE-2*GALAXY_WIDTH].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else if (i == GALAXY_SIZE-1)
			{
				if (sector[GALAXY_SIZE-2].star == true || sector[GALAXY_SIZE-GALAXY_WIDTH-1].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else if (i / GALAXY_WIDTH == 0)
			{
				if (sector[i-1].star == true || sector[i+1].star == true||sector[i+GALAXY_WIDTH].star==true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else if (i / GALAXY_WIDTH == GALAXY_HEIGHT-1)
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i - GALAXY_WIDTH].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else if (i % GALAXY_WIDTH == 0)
			{
				if (sector[i - GALAXY_WIDTH].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else if (i % GALAXY_WIDTH == GALAXY_WIDTH-1)
			{
				if (sector[i - 1].star == true || sector[i - GALAXY_WIDTH].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
			else
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true|| sector[i - GALAXY_WIDTH].star == true)
				{
					sector[i].planet.initialize(sector[i].loc, rng);
				}
			}
		}
	}
}

Sector Galaxy::get_sector(int i)
{
	return sector[i];
}