#include "Planet.h"
#include "Constants.h"

Planet::Planet()
{
	loc = EMPTY;
	food = 0;
	uranium = 0;
	antimatter = 0;
	dark_matter = 0;
	antimatter_bombs = 0;
	nuclear_missiles = 0;
	warp_engines = 0;
	production_points = 0;
	project = ' ';
	habitable = false;
	for (int i = 0; i < 9; i++)
	{
		map[i].yield = 0;
		map[i].improvement = ' ';
		map[i].resource = ' ';
		for (int j = 0; j < 5; j++)
		{
			map[i].people[j].ability = 0;
			map[i].people[j].job = ' ';
			map[i].people[j].number = -1;
			map[i].people[j].reeducations = 0;
		}
	}
}

void Planet::initialize (Location location, std::mt19937& rng)
{
	std::uniform_int_distribution<int> d2(1, 2);
	std::uniform_int_distribution<int> d3(1, 3);
	std::uniform_int_distribution<int> d6(1, 6);
	int resourcenum;
	loc = location;
	food = 0;
	uranium = 0;
	antimatter = 0;
	dark_matter = 0;
	antimatter_bombs = 0;
	nuclear_missiles = 0;
	warp_engines = 0;
	production_points = 0;
	project = ' ';
	if (d2(rng) == 1)
		habitable = true;
	else
		habitable = false;
	for (int i = 0; i < 9; i++)
	{
		if (d2(rng) == 1)
			map[i].yield = 0;
		else if (d2(rng)==1)
			map[i].yield = 1;
		else if (d3(rng)==1)
			map[i].yield = 3;
		else
			map[i].yield = 2;
		map[i].improvement = ' ';
		for (int j = 0; j < 5; j++)
		{
			map[i].people[j].ability = 0;
			map[i].people[j].job = ' ';
			map[i].people[j].number = -1;
			map[i].people[j].reeducations = 0;
		}
		if (d6(rng)==1)
		{
			resourcenum = d3(rng);
			if (resourcenum == 1)
				map[i].resource = 'u';
			else if (resourcenum == 2)
				map[i].resource = 'a';
			else
				map[i].resource = 'd';
		}
		else
			map[i].resource = ' ';
	}
}

int Planet::get_population()
{
	return 0;
}

int Planet::get_engineering()
{
	return 0;
}

int Planet::get_defense()
{
	return 0;
}

bool Planet::is_habitable()
{
	return habitable;
}

void Planet::set_loc(Location newloc)
{
	loc.x = newloc.x;
	loc.y = newloc.y;
}

Location Planet::get_loc()
{
	return loc;
}

void Planet::set_habitable(bool h)
{
	habitable = h;
}

bool Planet::get_habitable()
{
	return habitable;
}

tile Planet::get_tile(int i)
{
	return map[i];
}

int Planet::get_tile_yield(int i)
{
	return map[i].yield;
}