#pragma once

#include "Location.h"
#include "Person.h"
#include <random>

struct tile
{
	int yield;//0-3
	char improvement;//F-farm C-city M-megacity A-antimatter mine U-uranium mine D-dark matter mine S-school L-laborotory W-workplant B-barracks
	char resource;//u-uranium a-antimatter d-dark matter
	Person people[5];
};

class Planet
{
public:
	Planet();
	void initialize(Location location, std::mt19937& rng);
	int get_population();
	int get_engineering();
	int get_defense();
	bool is_habitable();
	void set_loc(Location newloc);
	void set_habitable(bool h);
	Location get_loc();
	bool get_habitable();
	tile get_tile(int i);
	int get_tile_yield(int i);
private:
	bool habitable;
	Location loc;
	tile map[9];
	int food;
	int uranium;
	int antimatter;
	int dark_matter;
	int antimatter_bombs;
	int nuclear_missiles;
	int warp_engines;
	int production_points;
	char project; 
	//f-farm c-city M-megacity m-mine s-school l-laborotory w-workplant
	//b-barracks S-ship a-animatter bomb n-nuclear missile w-warp engine
	//t-terraform
};