#include "Player.h"

Player::Player()
{
	colour = Colors::Black;
	colony = new Planet[GALAXY_SIZE];
	ship = new Ship[GALAXY_SIZE];
	discovered = new bool[GALAXY_SIZE];
	discovered_planet = new Planet[GALAXY_SIZE];
	colonizing_planet = new Planet[GALAXY_SIZE];
	tech = new int[NUM_TECHS];
	for (int i = 0; i < GALAXY_SIZE; i++)
	{
		colony[i].set_loc(EMPTY);
		ship[i].set_loc(EMPTY);
		discovered[i] = false;
		discovered_planet[i].set_loc(EMPTY);
		colonizing_planet[i].set_loc(EMPTY);
	}
	for (int i = 0; i < NUM_TECHS; i++)
	{
		tech[i] = 0;
	}
}

Player::~Player()
{
	delete[] colony;
	delete[] ship;
	delete[] discovered;
	delete[] discovered_planet;
	delete[] colonizing_planet;
	delete[] tech;
}

void Player::add_colony(Planet p)
{
	int i = 0;
	while ( colony[i].get_loc() != EMPTY)
	{
		i++;
	}
	colony[i] = p;
}

void Player::add_discovered(Location loc)
{
	discovered[loc.y * GALAXY_WIDTH + loc.x] = true;
}

void Player::add_discovered_planet(Planet p)
{
	int i = 0;
	while (discovered_planet[i].get_loc() != EMPTY)
	{
		i++;
	}
	discovered_planet[i] = p;
}

void Player::set_colour(Color c)
{
	colour = c;
}

Color Player::get_colour()
{
	return colour;
}

bool Player::is_colony(Location loc)
{
	bool is_match = false;
	for (int i = 0; colony[i].get_loc() != EMPTY; i++)
	{
		if (colony[i].get_loc() == loc)
			is_match = true;
	}
	return is_match;
}

Planet Player::get_colony(int i)
{
	return colony[i];
}