#pragma once
#include "Planet.h"
#include "Ship.h"
#include "Colors.h"
#include <string>
#include "Constants.h"

struct TileNode
{
	Location loc;
	TileNode* link;
};

class Player
{
public:
	Player();
	~Player();
	void add_colony(Planet p);
	void add_discovered(Location loc);
	void add_discovered_planet(Planet p);
	void set_colour(Color c);
	Color get_colour();
	bool is_colony(Location loc);
	Planet get_colony(int i);
private:
	Color colour;
	Planet* colony;
	Ship* ship;
	bool* discovered;
	Planet* discovered_planet;
	Planet* colonizing_planet;
	int* tech;
	// 0 = WARP DRIVE, 1 = MEGACITIES, 2 = ANTIMATTER BOMBS,
	// 3 = ADVANCED AGRICULTURE, 4 = GENE MANIPULATION,
	// 5 = LIFE SUPPORT, 6 = TERRAFORMING, 7 = NUCLEAR MISSILES
	// 8 = OPTICS, 9 = TELEPORTATION
};