#include "Ship.h"
#include "Constants.h"

Ship::Ship()
{
	attacked = false;
	invaded = false;
	moves = 0;
	loc = EMPTY;
	health = 50;
	food = 0;
	uranium = 0;
	antimatter = 0;
	dark_matter = 0;
	antimatter_bombs = 0;
	nuclear_missiles = 0;
	warp_engines = 0;
	for (int i = 0; i < 3; i++)
	{
		people[i].number = -1;
	}
}

Ship::Ship(Location location)
{
	attacked = false;
	invaded = false;
	moves = 0;
	loc = location;
	health = 50;
	food = 0;
	uranium = 0;
	antimatter = 0;
	dark_matter = 0;
	antimatter_bombs = 0;
	nuclear_missiles = 0;
	warp_engines = 0;
	for (int i = 0; i < 3; i++)
	{
		people[i].number = -1;
	}
}

int Ship::get_engineering()
{
	int engineering = 0;
	for (int i = 0; i < 3; i++)
	{
		if (people[i].number != -1 && people[i].job == 'e')
			engineering += people[i].ability;
	}
	return engineering;
}

int Ship::get_invasion_pts()
{
	int invasion_pts = 0;
	for (int i = 0; i < 3; i++)
	{
		if (people[i].number != -1 && people[i].job == 's')
			invasion_pts += people[i].ability;
	}
	return invasion_pts;
}

int Ship::get_population()
{
	int population = 0;
	for (int i = 0; i < 3; i++)
		if (people[i].number != -1)
			population++;
	return population;
}

Location Ship::get_loc()
{
	return loc;
}

int Ship::get_health()
{
	return health;
}

int Ship::get_moves()
{
	return moves;
}

int Ship::get_food()
{
	return food;
}

int Ship::get_uranium()
{
	return uranium;
}

int Ship::get_antimatter()
{
	return antimatter;
}

int Ship::get_darkmatter()
{
	return dark_matter;
}

int Ship::get_antimatter_bombs()
{
	return antimatter_bombs;
}

int Ship::get_nuclear_missiles()
{
	return nuclear_missiles;
}

int Ship::get_warp_engines()
{
	return warp_engines;
}

bool Ship::has_attacked()
{
	return attacked;
}

bool Ship::has_invaded()
{
	return invaded;
}

Person* Ship::get_people()
{
	Person* pp = people;
	return pp;
}

void Ship::set_loc(Location l)
{
	loc = l;
}